using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Maestros._0_Modelos;
using Exferia_Aplicacion.Modelos_MantenimientoSimple;
using System.Transactions;
using System.Data.SqlClient;

namespace Exferia_Maestros._1_Datos
{
    public class MAE_TiposGastos_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_MAE_TiposGastos_Listado_Modelo> g_lst_INTERNO_MAE_TiposGastos_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_TiposGastos).Name), _lst_CamposConRelacionABuscar, -1,null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_MAE_TiposGastos_Listado_Modelo != null) && (g_lst_INTERNO_MAE_TiposGastos_Listado_Modelo.Count() > 0))
                {
                    lst_MAE = g_lst_INTERNO_MAE_TiposGastos_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposGastos_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_MAE;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_TiposGastos).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_MAE_TiposGastos_Listado_Modelo != null) && (g_lst_INTERNO_MAE_TiposGastos_Listado_Modelo.Count() > 0))
                {
                    dnm_MAE = g_lst_INTERNO_MAE_TiposGastos_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposGastos_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                //Filtros de Opciones
                //Datos del Padre si los tuviera .........................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";
                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    lng_Padre_id = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].VALOR;
                    str_Padre_Opcion = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].NOMBRE_CAMPO;
                }

                string str_SQL =
                        " SELECT " +
                            nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.id) + " = " + nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.id) + "," +
                            nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.codigo) + " = " + nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.codigo) + "," +
                            nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.descripcion) + " = " + nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.descripcion) + "," +
                            nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.relacionadoConVehiculo) + " = " + nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.relacionadoConVehiculo) + "," +
                            //ids
                            nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.idEmpresa) + " = " + nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.idEmpresa) + "," +
                            //Empresa
                            (
                              (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.Empresa)))
                                ?
                                    (
                                        nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.Empresa_Codigo) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.codigo) + "," +
                                        nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.Empresa_Descripcion) + " =" + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.descripcion) + "," +
                                        nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.Empresa_FechaBorrado) + " =" + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.fechaBorrado) 
                                    )
                                :
                                    (
                                        nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.Empresa_Codigo) + " = ''," +
                                        nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.Empresa_Descripcion) + " = ''," +
                                        nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.Empresa_FechaBorrado) + " = NULL "
                                    )
                            ) +
                  " FROM " + nameof(MAE_TiposGastos) +
                        //Empresa
                        (
                             (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.Empresa)))
                                ?
                                    (
                                     " LEFT JOIN " + nameof(GEN_Empresas) + " ON " + nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.idEmpresa) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.id)
                                    )
                                : ("")
                        ) +
                        " WHERE " + nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.fechaBorrado) + " IS null AND " +
                            " ( " + nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.idEmpresa) + "=@idEmpresa" + 
                                (
                                    (_lst_idEmpresasRelacionadas != null && _lst_idEmpresasRelacionadas.Count > 0) 
                                        ? (" OR " + nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.idEmpresa) + " in (" + str_Filtros_Empresas + ") ")
                                        : " "
                                ) +
                            " ) AND " +
                            (_lng_id > -1 ? nameof(MAE_TiposGastos) + "." + (nameof(MAE_TiposGastos.id) + "=@id") : "1 = 1") + " AND " +
                            //Filtro por datos del padre relacionado
                            (
                                !str_Padre_Opcion.Equals("")
                                    //Empresa
                                    ? str_Padre_Opcion.Equals(Variables.G_STR_OPCION_GEN_EMPRESA)
                                        ? (nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.idEmpresa) + "=@id_Padre")
                                        : ("1 = 1")
                                    : ("1 = 1")
                            );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@id", _lng_id));
                lst_Parametros.Add(new SqlParameter("@id_Padre", lng_Padre_id));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_lst_INTERNO_MAE_TiposGastos_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_TiposGastos_Listado_Modelo>(str_SQL, arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposGastos_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }

        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_MAE_TiposGastos_Listado_Modelo g_mdl_INTERNO_MAE_TiposGastos_Listado_Modelo_F3 = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_TiposGastos).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_MAE_TiposGastos_Listado_Modelo_F3 != null)
                {
                    dnm_MAE = g_mdl_INTERNO_MAE_TiposGastos_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposGastos_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_MAE = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(MAE_TiposGastos).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_MAE_TiposGastos_Listado_Modelo_F3 != null)
                {
                    dnm_MAE = g_mdl_INTERNO_MAE_TiposGastos_Listado_Modelo_F3;
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposGastos_Datos) + "/" + nameof(Obtener_F3_PorId), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_MAE;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionas);

                //Filtros de Opciones
                //Datos del Padre si los tuviera .........................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";
                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    lng_Padre_id = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].VALOR;
                    str_Padre_Opcion = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].NOMBRE_CAMPO;
                }

                string str_SQL =
                      " SELECT distinct " +
                          nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.id) + " = " + nameof(MAE_TiposGastos.id) + "," +
                          nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.codigo) + " = " + nameof(MAE_TiposGastos.codigo) + "," +
                          nameof(INTERNO_MAE_TiposGastos_Listado_Modelo.descripcion) + " = " + nameof(MAE_TiposGastos.descripcion) +
                  " FROM " + nameof(MAE_TiposGastos) +
                  " WHERE " + nameof(MAE_TiposGastos.fechaBorrado) + " IS null AND " +
                           " ( " + nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.idEmpresa) + "=@idEmpresa" + 
                                (
                                    (_lst_idEmpresasRelacionas != null && _lst_idEmpresasRelacionas.Count > 0) 
                                        ? (" OR " + nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.idEmpresa) + " in (" + str_Filtros_Empresas + ") ") 
                                        : " "
                                ) +
                            " ) AND " +
                          (
                           (_lng_id > -1)
                             ? (nameof(MAE_TiposGastos.id) + " = " + _lng_id)
                             : (
                                  //Filtrar por Codigo
                                  (_str_CampoBusqueda.Equals(nameof(MAE_TiposGastos.codigo)))
                                      ? (nameof(MAE_TiposGastos.codigo) + "=@Filtro")
                                      //Filtrar por Descripcion
                                      : (nameof(MAE_TiposGastos.descripcion) + "=@Filtro")
                               )
                          )
                          + " AND " +
                          //Filtro por datos del padre relacionado
                          (
                              !str_Padre_Opcion.Equals("")
                                  //Empresa
                                  ? str_Padre_Opcion.Equals(Variables.G_STR_OPCION_GEN_EMPRESA)
                                      ? (nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.idEmpresa) + "=@id_Padre")
                                      : ("1 = 1")
                                  : ("1 = 1")
                          );

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@Filtro", _str_Filtro));
                lst_Parametros.Add(new SqlParameter("@id_Padre", lng_Padre_id));

                object[] arr_Parametros = lst_Parametros.ToArray();

                //Rellenar el Modelo
                g_mdl_INTERNO_MAE_TiposGastos_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_MAE_TiposGastos_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposGastos_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener
        private dynamic g_dnm_Modelo_Obtener = null;
        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                   " SELECT distinct " +
                       nameof(INTERNO_MantenimientoSimple_Modelo.id) + " = " + nameof(MAE_TiposGastos.id) + "," +
                       nameof(INTERNO_MantenimientoSimple_Modelo.codigo) + " = " + nameof(MAE_TiposGastos.codigo) + "," +
                       nameof(INTERNO_MantenimientoSimple_Modelo.descripcion) + " = " + nameof(MAE_TiposGastos.descripcion) + "," +
                       nameof(INTERNO_MantenimientoSimple_Modelo.Auxiliar_7) + " = (CASE WHEN " + nameof(MAE_TiposGastos.relacionadoConVehiculo) + " IS NULL THEN 'False' ELSE " + nameof(MAE_TiposGastos.relacionadoConVehiculo) + " END)," +
                       nameof(INTERNO_MantenimientoSimple_Modelo.fechaBorrado) + " = " + nameof(MAE_TiposGastos.fechaBorrado) + "," +
                       nameof(INTERNO_MantenimientoSimple_Modelo.idEmpresa) + " = " + nameof(MAE_TiposGastos.idEmpresa) +
               " FROM " + nameof(MAE_TiposGastos) +
               " WHERE " + nameof(MAE_TiposGastos.fechaBorrado) + " IS null AND " +
                           nameof(MAE_TiposGastos.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoSimple_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposGastos_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private MAE_TiposGastos g_mdl_MAE_TiposGastos = null;
        public MAE_TiposGastos Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(MAE_TiposGastos) + "." + nameof(MAE_TiposGastos.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposGastos_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_MAE_TiposGastos;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_MAE_TiposGastos = obj_Exferia_Entities.Database.SqlQuery<MAE_TiposGastos>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposGastos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion
        

        private string Obtener_Consulta_Modelo()
        {
            return
               " SELECT " +
                   nameof(MAE_TiposGastos.id) + " , " +
                   nameof(MAE_TiposGastos.codigo) + " , " +
                   nameof(MAE_TiposGastos.descripcion) + " , " +
                   nameof(MAE_TiposGastos.relacionadoConVehiculo) + " , " +
                   nameof(MAE_TiposGastos.idEmpresa) + " , " +
                   nameof(MAE_TiposGastos.fechaBorrado) +
               " FROM " + nameof(MAE_TiposGastos);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                INTERNO_MantenimientoSimple_Modelo mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar = (INTERNO_MantenimientoSimple_Modelo)_mdl_obj;
                MAE_TiposGastos mdl_MAE_TiposGastos_DatosViejos = new MAE_TiposGastos();

                // Ver si existe ######################################################################
                MAE_TiposGastos mdl_MAE_TiposGastos_Final = Obtener_Modelo_Por_Id(mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.id);
                //######################################################################################

                if (mdl_MAE_TiposGastos_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_MAE_TiposGastos_Final, mdl_MAE_TiposGastos_DatosViejos, false, false);

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_MAE_TiposGastos_Final, mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar);

                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(MAE_TiposGastos) +
                                           " SET " +
                                               nameof(MAE_TiposGastos.codigo) + "=@codigo," +
                                               nameof(MAE_TiposGastos.descripcion) + "=@descripcion," +
                                               nameof(MAE_TiposGastos.relacionadoConVehiculo) + "=@relacionadoConVehiculo," +
                                               nameof(MAE_TiposGastos.idEmpresa) + "=@idEmpresa," +
                                               nameof(MAE_TiposGastos.fechaBorrado) + "=@fechaBorrado " +
                                           " WHERE " +
                                               nameof(MAE_TiposGastos.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.descripcion),
                        new SqlParameter("@relacionadoConVehiculo",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.Auxiliar_7),
                        new SqlParameter("@idEmpresa",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.idEmpresa),
                        mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.id;
                }
                else
                {
                    mdl_MAE_TiposGastos_Final = new MAE_TiposGastos();

                    //Tipo de Accion que se va a realizar
                    mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_MAE_TiposGastos_Final, mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(MAE_TiposGastos) +
                                               " (" +
                                                       nameof(MAE_TiposGastos.codigo) + "," +
                                                       nameof(MAE_TiposGastos.descripcion) + "," +
                                                       nameof(MAE_TiposGastos.relacionadoConVehiculo) + "," +
                                                       nameof(MAE_TiposGastos.idEmpresa) + "," +
                                                       nameof(MAE_TiposGastos.fechaBorrado) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(MAE_TiposGastos.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@codigo," +
                                                   "@descripcion," +
                                                   "@relacionadoConVehiculo," +
                                                   "@idEmpresa," +
                                                   "@fechaBorrado" +
                                               " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.codigo),
                        new SqlParameter("@descripcion",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.descripcion),
                        new SqlParameter("@relacionadoConVehiculo",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.Auxiliar_7),
                        new SqlParameter("@idEmpresa",  mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.idEmpresa),
                        mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)

                    };
                    #endregion

                    //Id de la tabla
                    mdl_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_TiposGastos), mdl_MAE_TiposGastos_DatosViejos, mdl_MAE_TiposGastos_Final, mdl_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);

                //CRM
                /*if (Variables.G_BOL_CONEXION_SINCRONIZACIONCRM_ACTIVA)
                {
                    Sincronizar_CRM(mdl_MAE_TiposGastos_Final.id, false);
                }*/
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposGastos_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_ValorDevuelto_Modelo;
        }

        private void Cargar_DatosModelo(MAE_TiposGastos _mdl_MAE_TiposGastos, INTERNO_MantenimientoSimple_Modelo _mdl_INTERNO_MantenimientoSimple_Modelo)
        {
            //Cargar los datos Nuevos del Modelo
            _mdl_MAE_TiposGastos.id = _mdl_INTERNO_MantenimientoSimple_Modelo.id;
            _mdl_MAE_TiposGastos.codigo = _mdl_INTERNO_MantenimientoSimple_Modelo.codigo;
            _mdl_MAE_TiposGastos.descripcion = _mdl_INTERNO_MantenimientoSimple_Modelo.descripcion;
            _mdl_MAE_TiposGastos.idEmpresa = _mdl_INTERNO_MantenimientoSimple_Modelo.idEmpresa;
            _mdl_MAE_TiposGastos.relacionadoConVehiculo = _mdl_INTERNO_MantenimientoSimple_Modelo.Auxiliar_7;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                MAE_TiposGastos mdl_MAE_TiposGastos_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if(mdl_MAE_TiposGastos_Final != null)
                {
                    #region UPDATE
                    string str_SQL_Update = " UPDATE " + nameof(MAE_TiposGastos) +
                                                " SET " +
                                                nameof(MAE_TiposGastos.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(MAE_TiposGastos.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(MAE_TiposGastos), null, mdl_MAE_TiposGastos_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Sincronizar datos para descarga
                //CRM
                /*if (Variables.G_BOL_CONEXION_SINCRONIZACIONCRM_ACTIVA)
                {
                    Sincronizar_CRM(_lng_id, true);
                }*/

                //Devolver tambien el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposGastos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion

        #region Procedimiento Almacenados para Sincronizacion
        /*public INTERNO_ValorDevuelto_Modelo Sincronizar_CRM(long _lng_idTipoGasto, bool _bol_Borrado)
        {
            Exferia_Entities dbcontext = null;
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                dbcontext = new Exferia_Entities();
                dbcontext.Configuration.LazyLoadingEnabled = false;

                dbcontext.P_CRM_Sincronizar_UnRegistro_0_TodosLosTerminales(_lng_idTipoGasto,nameof(MAE_TiposGastos) ,_bol_Borrado);
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(MAE_TiposGastos_Datos) + "/" + nameof(Sincronizar_CRM), true);
            }
            finally
            {
                
                dbcontext.Database.Connection.Close();
                dbcontext.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }*/
        #endregion
    }
}
